#include "pins.h"

//#define UBRR 129
#define UBRR 10

void serial_init()
{
	UBRR0H = (uint8_t)(UBRR>>8);
	UBRR0L = (uint8_t)UBRR;

	UCSR0B = _BV(RXEN0)|_BV(TXEN0);
	UCSR0C = _BV(UCSZ01)|_BV(UCSZ00);

	DDRD |= _BV(PIND_TXD);
}

void serial_putc(uint8_t data)
{
   /*
      wait for empty transmit buffer 
   */

   while (!(UCSR0A & (1<<UDRE0)));

   /* 
      put data into buffer, sends the data 
   */

   UDR0 = data;
}

uint8_t serial_getc()
{
   /* 
      wait for data to be received 
   */

   while (!(UCSR0A & (1<<RXC0)));

   /* 
      get and return received data from buffer 
   */

   return UDR0;
}
